; ModuleID = 'input/kmp.c'
target datalayout = "e-m:e-p:32:32-i64:64-v128:64:128-a:0:32-n32-S64"
target triple = "armv4-none--eabi"

@cpl_main.str = private unnamed_addr constant [24 x i8] c"ABC ABCDAB ABCDABCDABDE\00", align 1
@.str = private unnamed_addr constant [8 x i8] c"ABCDABD\00", align 1

; Function Attrs: noinline norecurse nounwind
define void @preKmp(i8* nocapture readonly %x, i32 %m, i32* nocapture %kmpNext) #0 {
  store i32 -1, i32* %kmpNext, align 4, !tbaa !3
  %1 = icmp sgt i32 %m, 0
  br i1 %1, label %.preheader.preheader, label %._crit_edge

.preheader.preheader:                             ; preds = %0
  br label %.preheader

.preheader:                                       ; preds = %.preheader.preheader, %.backedge
  %j.05 = phi i32 [ %14, %.backedge ], [ -1, %.preheader.preheader ]
  %i.04 = phi i32 [ %13, %.backedge ], [ 0, %.preheader.preheader ]
  %2 = icmp sgt i32 %j.05, -1
  br i1 %2, label %.lr.ph, label %.critedge

.lr.ph:                                           ; preds = %.preheader
  %3 = getelementptr inbounds i8, i8* %x, i32 %i.04
  %4 = load i8, i8* %3, align 1
  br label %5

; <label>:5                                       ; preds = %.lr.ph, %9
  %j.11 = phi i32 [ %j.05, %.lr.ph ], [ %11, %9 ]
  %6 = getelementptr inbounds i8, i8* %x, i32 %j.11
  %7 = load i8, i8* %6, align 1, !tbaa !7
  %8 = icmp eq i8 %4, %7
  br i1 %8, label %.critedge.loopexit, label %9

; <label>:9                                       ; preds = %5
  %10 = getelementptr inbounds i32, i32* %kmpNext, i32 %j.11
  %11 = load i32, i32* %10, align 4, !tbaa !3
  %12 = icmp sgt i32 %11, -1
  br i1 %12, label %5, label %.critedge.loopexit

.critedge.loopexit:                               ; preds = %5, %9
  %j.1.lcssa.ph = phi i32 [ %j.11, %5 ], [ %11, %9 ]
  br label %.critedge

.critedge:                                        ; preds = %.critedge.loopexit, %.preheader
  %j.1.lcssa = phi i32 [ %j.05, %.preheader ], [ %j.1.lcssa.ph, %.critedge.loopexit ]
  %13 = add nuw nsw i32 %i.04, 1
  %14 = add nsw i32 %j.1.lcssa, 1
  %15 = getelementptr inbounds i8, i8* %x, i32 %13
  %16 = load i8, i8* %15, align 1, !tbaa !7
  %17 = getelementptr inbounds i8, i8* %x, i32 %14
  %18 = load i8, i8* %17, align 1, !tbaa !7
  %19 = icmp eq i8 %16, %18
  br i1 %19, label %20, label %.backedge

; <label>:20                                      ; preds = %.critedge
  %21 = getelementptr inbounds i32, i32* %kmpNext, i32 %14
  %22 = load i32, i32* %21, align 4, !tbaa !3
  br label %.backedge

.backedge:                                        ; preds = %.critedge, %20
  %.sink = phi i32 [ %22, %20 ], [ %14, %.critedge ]
  %23 = getelementptr inbounds i32, i32* %kmpNext, i32 %13
  store i32 %.sink, i32* %23, align 4
  %exitcond = icmp eq i32 %13, %m
  br i1 %exitcond, label %._crit_edge.loopexit, label %.preheader

._crit_edge.loopexit:                             ; preds = %.backedge
  br label %._crit_edge

._crit_edge:                                      ; preds = %._crit_edge.loopexit, %0
  ret void
}

; Function Attrs: argmemonly nounwind
declare void @llvm.lifetime.start(i64, i8* nocapture) #1

; Function Attrs: argmemonly nounwind
declare void @llvm.lifetime.end(i64, i8* nocapture) #1

; Function Attrs: noinline norecurse nounwind
define i32 @KMP(i8* nocapture readonly %x, i32 %m, i8* nocapture readonly %y, i32 %n) #0 {
  %kmpNext = alloca [32 x i32], align 4
  %1 = bitcast [32 x i32]* %kmpNext to i8*
  call void @llvm.lifetime.start(i64 128, i8* %1) #4
  %2 = getelementptr inbounds [32 x i32], [32 x i32]* %kmpNext, i32 0, i32 0
  call void @preKmp(i8* %x, i32 %m, i32* %2)
  br label %3

; <label>:3                                       ; preds = %.critedge, %0
  %i.0 = phi i32 [ 0, %0 ], [ %16, %.critedge ]
  %j.0 = phi i32 [ 0, %0 ], [ %17, %.critedge ]
  %4 = icmp slt i32 %j.0, %n
  br i1 %4, label %.preheader, label %.loopexit.loopexit

.preheader:                                       ; preds = %3
  %5 = icmp sgt i32 %i.0, -1
  br i1 %5, label %.lr.ph, label %.critedge

.lr.ph:                                           ; preds = %.preheader
  %6 = getelementptr inbounds i8, i8* %y, i32 %j.0
  %7 = load i8, i8* %6, align 1
  br label %8

; <label>:8                                       ; preds = %.lr.ph, %12
  %i.12 = phi i32 [ %i.0, %.lr.ph ], [ %14, %12 ]
  %9 = getelementptr inbounds i8, i8* %x, i32 %i.12
  %10 = load i8, i8* %9, align 1, !tbaa !7
  %11 = icmp eq i8 %10, %7
  br i1 %11, label %.critedge.loopexit, label %12

; <label>:12                                      ; preds = %8
  %13 = getelementptr inbounds [32 x i32], [32 x i32]* %kmpNext, i32 0, i32 %i.12
  %14 = load i32, i32* %13, align 4, !tbaa !3
  %15 = icmp sgt i32 %14, -1
  br i1 %15, label %8, label %.critedge.loopexit

.critedge.loopexit:                               ; preds = %8, %12
  %i.1.lcssa.ph = phi i32 [ %i.12, %8 ], [ %14, %12 ]
  br label %.critedge

.critedge:                                        ; preds = %.critedge.loopexit, %.preheader
  %i.1.lcssa = phi i32 [ %i.0, %.preheader ], [ %i.1.lcssa.ph, %.critedge.loopexit ]
  %16 = add nsw i32 %i.1.lcssa, 1
  %17 = add nuw nsw i32 %j.0, 1
  %18 = icmp slt i32 %16, %m
  br i1 %18, label %3, label %19

; <label>:19                                      ; preds = %.critedge
  %.lcssa9 = phi i32 [ %17, %.critedge ]
  %.lcssa = phi i32 [ %16, %.critedge ]
  %20 = sub nsw i32 %.lcssa9, %.lcssa
  br label %.loopexit

.loopexit.loopexit:                               ; preds = %3
  br label %.loopexit

.loopexit:                                        ; preds = %.loopexit.loopexit, %19
  %.0 = phi i32 [ %20, %19 ], [ -1, %.loopexit.loopexit ]
  call void @llvm.lifetime.end(i64 128, i8* %1) #4
  ret i32 %.0
}

; Function Attrs: nounwind
define i32 @cpl_main() #2 {
  %str = alloca [24 x i8], align 1
  %1 = getelementptr inbounds [24 x i8], [24 x i8]* %str, i32 0, i32 0
  call void @llvm.lifetime.start(i64 24, i8* %1) #4
  call void @llvm.memcpy.p0i8.p0i8.i32(i8* %1, i8* getelementptr inbounds ([24 x i8], [24 x i8]* @cpl_main.str, i32 0, i32 0), i32 24, i32 1, i1 false)
  %2 = call i32 @KMP(i8* getelementptr inbounds ([8 x i8], [8 x i8]* @.str, i32 0, i32 0), i32 7, i8* %1, i32 25)
  tail call void @dump_int(i32 %2) #4
  %3 = getelementptr inbounds [24 x i8], [24 x i8]* %str, i32 0, i32 %2
  call void @dump_string(i8* %3) #4
  call void @llvm.lifetime.end(i64 24, i8* %1) #4
  ret i32 0
}

; Function Attrs: argmemonly nounwind
declare void @llvm.memcpy.p0i8.p0i8.i32(i8* nocapture, i8* nocapture readonly, i32, i32, i1) #1

declare void @dump_int(i32) #3

declare void @dump_string(i8*) #3

attributes #0 = { noinline norecurse nounwind "disable-tail-calls"="false" "less-precise-fpmad"="false" "no-frame-pointer-elim"="true" "no-frame-pointer-elim-non-leaf" "no-infs-fp-math"="false" "no-nans-fp-math"="false" "stack-protector-buffer-size"="8" "target-cpu"="strongarm" "target-features"="+soft-float,+strict-align,-crypto,-neon" "unsafe-fp-math"="false" "use-soft-float"="true" }
attributes #1 = { argmemonly nounwind }
attributes #2 = { nounwind "disable-tail-calls"="false" "less-precise-fpmad"="false" "no-frame-pointer-elim"="true" "no-frame-pointer-elim-non-leaf" "no-infs-fp-math"="false" "no-nans-fp-math"="false" "stack-protector-buffer-size"="8" "target-cpu"="strongarm" "target-features"="+soft-float,+strict-align,-crypto,-neon" "unsafe-fp-math"="false" "use-soft-float"="true" }
attributes #3 = { "disable-tail-calls"="false" "less-precise-fpmad"="false" "no-frame-pointer-elim"="true" "no-frame-pointer-elim-non-leaf" "no-infs-fp-math"="false" "no-nans-fp-math"="false" "stack-protector-buffer-size"="8" "target-cpu"="strongarm" "target-features"="+soft-float,+strict-align,-crypto,-neon" "unsafe-fp-math"="false" "use-soft-float"="true" }
attributes #4 = { nounwind }

!llvm.module.flags = !{!0, !1}
!llvm.ident = !{!2}

!0 = !{i32 1, !"wchar_size", i32 4}
!1 = !{i32 1, !"min_enum_size", i32 4}
!2 = !{!"clang version 3.8.0-2ubuntu4 (tags/RELEASE_380/final)"}
!3 = !{!4, !4, i64 0}
!4 = !{!"int", !5, i64 0}
!5 = !{!"omnipotent char", !6, i64 0}
!6 = !{!"Simple C/C++ TBAA"}
!7 = !{!5, !5, i64 0}
